QGIS Application - Bug report #9626
Crash when adding OpenLayers layer
2014-02-23 12:43 PM - Saber Razmjooei

Status: Closed

Priority: Normal

Assignee: Martin Dobias

Category: Map Canvas

Affected QGIS version:master Regression?: No
Operating System: Ubuntu Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corruptsdata: Copied to github as #: 18199
Description

Error | get prior to crashing QGIS:

undefined[0]: TypeError: 'null' is not an object

This happens immediately after MTR merge. Maybe due to the fact that MTR does not support plugin layer.

Subtasks:
Bug report # 9860: openlayers plugin crashes qgis master Rejected

Associated revisions

Revision 4b820362 - 2014-02-24 01:35 AM - Jiirgen Fischer

fix crash in network access manager (fixes #9626)

History

#1 - 2014-02-23 12:48 PM - Saber Razmjooei

QGIS code revision: bc87d51

Affected version should be QGIS 2.3.0-Master

#2 - 2014-02-23 01:49 PM - Etienne Tourigny

confirmed. Here is debug output.

CANVAS refresh!

CACHE VALID: 0

src/core/qgsmaprendererjob.cpp: 546: (prepareJobs) Rendering at layer item OpenLayers_plugin_layer20140223184848905
src/core/gqgsmaprendererjob.cpp: 563: (preparedobs) layer Google Streets: minscale:0 maxscale:1e+08 scaledepvis:0
extent:-20037508.3399999998509884,-20037508.3399999998509884 : 20037508.3399999998509884,20037508.3399999998509884
blendmode:0

src/core/qgsmaprendererjob.cpp: 579: (preparedJobs) extent 1:-35297280.4943747147917747,-21039383.7569999992847443 :
35297280.4943747147917747,21039383.7569999992847443

src/core/qgsmaprendererjob.cpp: 580: (preparedJobs) extent 2: Empty

src/core/qgsmaprendererjob.cpp: 891: (renderLayerStatic) job 81b3720 start

OpenlayersLayer draw
page file: file:////home/tourigny/.qgis2/python/plugins/openlayers_plugin/html/google_streets.html
QGIS died on signal 11CANVAS update timer!

CANVAS update timer!

CANVAS update timer!

CANVAS update timer!

CANVAS update timer!

Could not attach to process. If your uid matches the uid of the target
process, check the setting of /proc/sys/kernel/yama/ptrace_scope, or try
again as the root user. For more details, see /etc/sysctl.d/10-ptrace.conf
ptrace: Operation not permitted.

No thread selected

No stack.

gdb returned 0

Aborted

#3 - 2014-02-23 01:51 PM - Etienne Tourigny
- Subject changed from QGIS 2.3.0 Master freezes when adding OpenLayers layer to QGIS 2.3.0 Master crashes when adding OpenLayers layer

#4 - 2014-02-23 02:11 PM - Etienne Tourigny
- Crashes QGIS or corrupts data changed from No to Yes

#5 - 2014-02-23 04:35 PM - Jiirgen Fischer

- Status changed from Open to Closed

Fixed in changeset commit:"4b820362c2eb3529bd19e37e40210233b03c92b6".

#6 - 2014-02-23 05:09 PM - Jiirgen Fischer

Jurgen Fischer wrote:

Fixed in changeset commit:"4b820362c2eb3529bd19e37e40210233b03c92b6".

Still crashes - but now in QWebPage. | guess it's invoked by the plugin from a rendering thread, which QWebPage doesn't support (see QThreadPool ,

QRunnable and objects that need to be created in main thread).

#7 - 2014-02-23 05:47 PM - Etienne Tourigny

Quick fix would be to render all plugin layers in the main thread to avoid any problems like this one.

Ideally, plugin layers should have a variable/function canRenderMultiThread() to let simple plugin layers be rendered in a separate thread (but by default,
rendered in the main thread).

For this particular plugin, perhaps it can be tweaked following this :
http://gt-project.org/doc/qgt-4.8/qwebpage.html#using-qwebpage-in-a-widget-less-environment

#8 - 2014-02-23 07:06 PM - Martin Dobias

2025-04-27 2/7


http://qt-project.org/forums/viewthread/6429/
http://qt-project.org/forums/viewthread/6429/
http://qt-project.org/doc/qt-4.8/qwebpage.html#using-qwebpage-in-a-widget-less-environment

Actually it is not a general problem of plugin layers. For example, the Crayfish plugin (which also uses QgsPluginLayer) works fine without any updates.
| strongly prefer not to have optional rendering of plugin layers in main thread as this would make everything much more complex - imagine that if QGIS
wants to render 5 layers and the plugin layer is in the middle of the list, in sequential rendering you would need to: render two layers in a worker thread,
when it is done render plugin layer in main thread and then continue in the worker thread.

My preferred solution would be to adapt plugins that have this kind of issue. In addition to implementing QgsMapLayer::draw() they can use new API for
map layer rendering:

- implement QgsMapLayer::createMapRenderer() that will return a new QgsMapLayerRenderer object. This method is called in main thread at the
beginning of the rendering. Ideally the method should not do any heavy work as this would block the main thread

- implement render() method in a subclass of QgsMapLayerRenderer - this function is called in the worker thread and should do the rendering

#9 - 2014-02-23 07:12 PM - Nathan Woodrow

Couldn't we solve this issue by exposing the QgsDataProvider stuff to Python and implement this stuff as data providers rather then plugin layers. The

open layers plugin should really be done as a raster data provider, and something like crayfish done as a vector provider.

It's not going to solve it directly but | guess it moves the logic to the correct location.

#10 - 2014-02-23 07:27 PM - Martin Dobias
Nathan: currently there is a technical problem that providers are handled by core library, but Python plugins are handled at the level of QGIS application. It
also means that in custom applications the custom data providers would not be available. Of course it is nothing that couldn't be sorted out, but at the same

time it is quite nice to have providers more under control (I think of them as slightly more low-level pieces of code).

In general | agree that openlayers could be done as a raster data provider (preferably inside qgis source tree) at some point.

#11 - 2014-02-23 07:53 PM - Etienne Tourigny

The core problem specific to the openlayers plugin, as Jirgen wrote, is that it relies on QWebPage and QWebFrame, which not thread-safe because of
GUI elements, supposedly.

That is regardless of whether or not it is implemented as a plugin layer or data provider.

Is there an alternative to QWebPage that is thread-safe?

Also, there might be other plugins with a similar problem (i.e. not thread-safe). It might prove necessary to allow those to render in the main thread, but |
guess we can wait and see if any pop up.

#12 - 2014-02-23 07:57 PM - Nathan Woodrow
- Tag set to MTR

Added the MTR tag to keep track of any threaded rendering issues.

#13 - 2014-02-23 08:06 PM - Martin Dobias

Etienne: | believe there is no need to look for alternatives of QWebPage - it is just about changing how the QWebPage is being used. | see no problem in
doing all communication with QWebPage in main thread using a helper object that would then pass the rendered image through queued signal to the

worker thread (which would start its event loop to receive the signal).

#14 - 2014-02-23 08:59 PM - Etienne Tourigny

Martin - | have just tested my plugin tileindex, which works with qgis 2.2, and it crashes also, because it uses QPixMap to generate a preview pixmap using

QgsRasterLayer::previewAsPixmap.

TileIndex plugin : reading raster /data/research/work/gls/LE72280622009192_RGB.tif

Warning: QPixmap: It is not safe to use pixmaps outside the GUI thread

Stacktrace (piped through c+-+filt):

/home/softdev/bin/qgis[0x55e5b7]

/home/softdev/bin/qgis(myMessageOutput(QtMsgType, char const*)+0xe2)[0x55e996]
/ust/lib/x86_64-linux-gnu/libQtCore.so.4(gqt_message_output(QtMsgType, char const*)+0x30)[0x7ffff2ca14d0]
/ust/lib/x86_64-linux-gnu/libQtCore.so.4(+0x71938)[0x7ffff2ca1938]
/ust/lib/x86_64-linux-gnu/libQtCore.so.4(gWarning(char const®, ...)+0x94)[0x7ffff2ca2084]
/ust/lib/x86_64-linux-gnu/libQtGui.so0.4(+0x29f28c)[0x7{fff222228¢]
/ust/lib/x86_64-linux-gnu/libQtGui.so.4(QPixmap::QPixmap(QSize const&)+0x34)[0x7{fff2223264]
/home/softdev/lib/libqgis_core.so0.2.3.0(QgsRasterLayer::previewAsPixmap(QSize, QColor)+0x43)[0x7ffff42f5c51]
/home/softdev/share/qgis/python/qgis/core.so(+0x3dbe10)[0x7fffcd363e10]
/ust/lib/x86_64-linux-gnu/libpython2.7.s0.1.0(PyEval_EvalFrameEx+0x5e75)[0x7fffceb138d5]
/usr/lib/x86_64-linux-gnu/libpython2.7.s0.1.0(PyEval_EvalFrameEx+0x5c03)[0x7fffceb13663]
/ust/lib/x86_64-linux-gnu/libpython2.7.s0.1.0(PyEval_EvalCodeEx+0x81a)[0x7fffceba72fa]
/usr/lib/x86_64-linux-gnu/libpython2.7.s0.1.0(+0xff4a6)[0x7fffceba74a6]
/usr/lib/x86_64-linux-gnu/libpython2.7.s0.1.0(PyObject_Call+0x4e)[0x7fffcebd9d8e]
Jusr/lib/x86_64-linux-gnu/libpython2.7.s0.1.0(+0xa106d)[0x7fffceb4906d]
/usr/lib/x86_64-linux-gnu/libpython2.7.s0.1.0(PyObject_Call+0x4e)[0x7fffcebd9d8e]
/ust/lib/x86_64-linux-gnu/libpython2.7.s0.1.0(PyEval_CallObjectWithKeywords+0x47)[0x7fffcebdab37]
/usr/lib/python2.7/dist-packages/sip.so(+0x98e2)[0x7fffce8938e2]
/home/softdev/share/qgis/python/qgis/core.so(sipVH_core_45(PyGlLState_ STATE, void (*)(_sipSimpleWrapper*, PyGILState STATE),
_sipSimpleWrapper*, _object*, QgsFeature&)+0x70)[0x7fffcd2052ef]
/home/softdev/share/qgis/python/qgis/core.so(sipQgsFeatureRendererV2::symbolForFeature(QgsFeature&)+0x87)[0x7fffcd2f0cf1]

Program received signal SIGFPE, Arithmetic exception.

[Switching to Thread 0x7fffobb14{700 (LWP 11969)]

0x00007ffff42f5d7c in QgsRasterLayer::previewAsPixmap (this=0x7fffb0011000, size=..., bgColor=...) at
/data/src/qgis/qgis-etiennesky/src/core/raster/qgsrasterlayer.cpp:1110

1110  if ( myExtent.width() / myExtent.height() >= myQPixmap.width() / myQPixmap.height() )

(gdb)

(gdb)

(gdb)

(gdb) bt

#0 0x00007ffff42f5d7c in QgsRasterLayer::previewAsPixmap (this=0x7fffb0011000, size=..., bgColor=...) at
/data/src/qgis/qgis-etiennesky/src/core/raster/qgsrasterlayer.cpp:1110

I guess | will wait for your instructions on how to update plugins to work with MTR.

By the way - pretty impressive stuff!!

#15 - 2014-02-23 09:20 PM - Martin Dobias
Yeah the Qt warning says it all - QPixmap should not be used in a thread. And, QgsRasterLayer::previewAsPixmap() should be ideally replaced by

previewAsImage() - as pixmaps also do not work without running X server.

#16 - 2014-02-23 09:26 PM - Etienne Tourigny

ok, I'll look into that within the next few weeks, if nothing has changed. Add new function QgsRasterLayer::previewAsImage() and deprecate

previewAsPixmap()

#17 - 2014-02-23 11:55 PM - Jiirgen Fischer

Etienne Tourigny wrote:

Quick fix would be to render all plugin layers in the main thread to avoid any problems like this one.

The posted link has a solution approach for the plugin(s), doesn'tit? The plugin should move it's QWebPage to the main thread and communicate with it

via signals/slots. To me this is a plugin issue now.

#18 - 2014-02-24 07:22 AM - Etienne Tourigny

| have added QgsRasterLayer::previewAsIimage() in 75a2edb and updated the tileindexplugin (in github for now).

However, it is considerably slower than drawing on a pixmap (because it doesn't use hardware acceleration).

SO | didn't deprecate previewAsPixmap() but added a note to use previewAslmage() when rendering.

#19 - 2014-02-24 07:23 AM - Etienne Tourigny

Jurgen Fischer wrote:

Etienne Tourigny wrote:

Quick fix would be to render all plugin layers in the main thread to avoid any problems like this one.

The posted link has a solution approach for the plugin(s), doesn'tit? The plugin should move it's QWebPage to the main thread and communicate

with it via signals/slots. To me this is a plugin issue now.

can this issue be moved over to the OpenLayers plugin tracker?

#20 - 2014-02-24 07:25 AM - Etienne Tourigny
Martin Dobias wrote:
Etienne: | believe there is no need to look for alternatives of QWebPage - it is just about changing how the QWebPage is being used. | see no

problem in doing all communication with QWebPage in main thread using a helper object that would then pass the rendered image through queued

signal to the worker thread (which would start its event loop to receive the signal).
seems like the right approach - and you seem best suited to implement that (I have no idea how do do this). Please let me know if/when you fix this, I'll see

if I can use the same approach for tileindex.

#21 - 2014-02-24 07:53 AM - Etienne Tourigny

Martin - sorry for more noise... but | have just realized that the rendering of tileindex (basically a custom renderer and symbol layer that render a Qlmage on
each polygon feature) is not done in parallel, even though | activated the parallel option. And there are 6 threads at a time that are started.

Is this expected? | imagine that renderers have to be updated for MTR to work effectively? In that case I'll wait for instructions on the ML. cheers!

#22 - 2014-02-24 05:03 PM - Etienne Tourigny

| just realized the MTR allots one thread per layer, it does not allocate various threads for layers features - so disregard previous comment.

#23 - 2014-02-24 07:25 PM - Etienne Tourigny

- Status changed from Closed to Reopened

#24 - 2014-02-25 03:04 AM - Martin Dobias

Why reopen? The original bug was fixed (thanks Jurgen!), the openlayers crash cannot be fixed in QGIS.

#25 - 2014-02-25 04:39 AM - Etienne Tourigny

- Status changed from Reopened to Closed

sorry - | reopened because the bug is still present.

| tried to move the ticket to the openlayers plugin tracker following http:/www.redmine.org/boards/2/topics/16789

but it seems | can only move it to the trackers in which | am dev. Can someone with proper privileges (say Pirmin) transfer it?

#26 - 2014-02-25 04:50 AM - Jiirgen Fischer

Etienne Tourigny wrote:

sorry - | reopened because the bug is still present.

| tried to move the ticket to the openlayers plugin tracker following http.//www.redmine.org/boards/2/topics/16789

but it seems | can only move it to the trackers in which | am dev. Can someone with proper privileges (say Pirmin) transfer it?

Why not file another bug there? This ticket was pointing at a problem is QGIS and that was fixed.

#27 - 2014-02-25 05:33 AM - Etienne Tourigny

| already did that - #9649
cheers!

#28 - 2014-02-25 07:38 AM - Jiirgen Fischer
- Subject changed from QGIS 2.3.0 Master crashes when adding OpenLayers layer to Crash when adding OpenLayers layer
- Affected QGIS version changed from 2.0.1 to master

#29 - 2014-02-27 08:51 AM - Tobias Preuss
- Status changed from Closed to Reopened
- File console-output.txt added

| experience the same problem with 2.3.0-Master. Here is the console output attached as a text file.

#30 - 2014-02-27 09:19 AM - Etienne Tourigny

- Status changed from Reopened to Closed

This bug was closed intentionally, because it is a problem with the plugin not the main application. See bug #9649

#31 - 2014-05-25 01:26 PM - Pirmin Kalberer
- Status changed from Closed to Reopened

After our discussions in Vienna, Martin offered to provide a reference implementation for Python plugins, which can be used as a guideline for the OL
plugin implementation. Since we're now in feature freeze, having a MT compatible OL implementation gets high priority.

#32 - 2014-05-25 11:23 PM - Martin Dobias
- Status changed from Reopened to Closed

A simple example plugin with QWebPage is here:
https://github.com/wonder-sk/ggis-mtr-example-plugin

Files

console-output.txt 6.57 KB 2014-02-27 Tobias Preuss
